xfstests: Test FITRIM where length is smaller than FSB
[xfstests-dev.git] / 103
1 #! /bin/bash
2 # FS QA Test No. 103
3 #
4 # Exercise the XFS nosymlinks inode flag
5 #
6 #-----------------------------------------------------------------------
7 # Copyright (c) 2000-2005 Silicon Graphics, Inc.  All Rights Reserved.
8 #
9 # This program is free software; you can redistribute it and/or
10 # modify it under the terms of the GNU General Public License as
11 # published by the Free Software Foundation.
12 #
13 # This program is distributed in the hope that it would be useful,
14 # but WITHOUT ANY WARRANTY; without even the implied warranty of
15 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
16 # GNU General Public License for more details.
17 #
18 # You should have received a copy of the GNU General Public License
19 # along with this program; if not, write the Free Software Foundation,
20 # Inc.,  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
21 #
22 #-----------------------------------------------------------------------
23 #
24 # creator
25 owner=nathans@sgi.com
26
27 seq=`basename $0`
28 echo "QA output created by $seq"
29
30 here=`pwd`
31 tmp=/tmp/$$
32 status=1        # failure is the default!
33 trap "rm -f $tmp.*; exit \$status" 0 1 2 3 15
34
35 # get standard environment, filters and checks
36 . ./common.rc
37 . ./common.filter
38
39 _create_scratch()
40 {
41         echo "*** mkfs"
42         if ! _scratch_mkfs_xfs >$tmp.out 2>&1
43         then
44                 cat $tmp.out
45                 echo "failed to mkfs $SCRATCH_DEV"
46                 exit 1
47         fi
48
49         echo "*** mount"
50         if ! _scratch_mount 2>/dev/null
51         then
52                 echo "failed to mount $SCRATCH_DEV"
53                 exit 1
54         fi
55 }
56
57 _filter_ln()
58 {
59     sed -e "s,SCRATCH_MNT/nosymlink/target - Operation not permitted,ln: creating symbolic link \`SCRATCH_MNT/nosymlink/target\' to \`SCRATCH_MNT/nosymlink/source\': Operation not permitted,g" \
60         -e "/SCRATCH_MNT.*to.*SCRATCH_MNT/! s,: Operation not permitted, to \`SCRATCH_MNT/nosymlink/source\': Operation not permitted,g" \
61         -e "s,failed to create,creating,"
62 }
63
64 _filter_noymlinks_flag()
65 {
66         _test_inode_flag nosymlinks $SCRATCH_MNT/nosymlink
67         if [ $? -eq 0 ]; then
68                 echo "--n-- SCRATCH_MNT/nosymlink"
69         else
70                 echo "----- SCRATCH_MNT/nosymlink"
71         fi
72 }
73
74 # real QA test starts here
75 _supported_os Linux IRIX
76 _supported_fs xfs
77 _require_command $XFS_IO_PROG xfs_io
78 _require_scratch
79
80 _create_scratch
81
82
83 echo "*** testing nosymlinks directories"
84 mkdir $SCRATCH_MNT/nosymlink
85 echo "*** setting nosymlinks bit"
86 $XFS_IO_PROG -r -c 'chattr +n' $SCRATCH_MNT/nosymlink
87 _filter_noymlinks_flag
88
89 touch $SCRATCH_MNT/nosymlink/source
90 ln -s $SCRATCH_MNT/nosymlink/source $SCRATCH_MNT/nosymlink/target 2>&1 \
91         | _filter_scratch | _filter_ln
92 ln $SCRATCH_MNT/nosymlink/source $SCRATCH_MNT/nosymlink/hardlinksareok
93
94 echo "*** 1st listing..."
95 find $SCRATCH_MNT | _filter_scratch
96
97 echo "*** clearing nosymlinks bit"
98 $XFS_IO_PROG -r -c 'chattr -n' $SCRATCH_MNT/nosymlink
99 _filter_noymlinks_flag
100
101 ln -s $SCRATCH_MNT/nosymlink/source $SCRATCH_MNT/nosymlink/target
102 ln $SCRATCH_MNT/nosymlink/source $SCRATCH_MNT/nosymlink/hardlinksareok2
103
104 echo "*** 2nd listing..."
105 find $SCRATCH_MNT | _filter_scratch
106
107 echo "*** finished testing nosymlinks directories"
108
109 status=0
110 exit